
// Loading Config-File
int cnc_load_config(void);

// Prepare the CNC-Machine for Start (x = Width, y = Height)
int cnc_start(int x, int y);

// Stop the CNC-Machine
int cnc_stop(void);

// Turn off the CNC-Machine
int cnc_off(void);

// Return CNC-Machine to Possition 0,0,0
int cnc_reset(void);

// Set the Speed of the X- and Y-Axis of the CNC-Machine
int cnc_set_speed_xy(int speed);

// Set the Softstart On/Off
int cnc_soft_start(int value);

// Set the Speed of the Z-Axis of the CNC-Machine
int cnc_set_speed_z(int speed);

// Change the Z-Axis and Tool of the CNC-Machine
int cnc_tool_change(int tool_nr);

// Go to X- und Y-Possition
int cnc_go_xy(int x, int y);

// Go to Z-Possition
int cnc_go_z(int pos_z);

// Go to Z-Possition
int cnc_check_z(void);

// Addition Drill and Pen commands
int drill_on(void);
int drill_off(void);
int drill_set_speed(int speed);
int drill(void);
int pen(int updown);



int (*cncout_check_z[10]) (void);
int (*cncout_set_speed_xy[10]) (int speed);
int (*cncout_set_speed_z[10]) (int speed);
int (*cncout_reset[10]) (void);
int (*cncout_start[10]) (int x, int y);
int (*cncout_stop[10]) (void);
int (*cncout_off[10]) (void);
int (*cncout_tool_change[10]) (int tool_nr);
int (*cncout_go_xy[10]) (int x, int y);
int (*cncout_go_x[10]) (int x);
int (*cncout_go_y[10]) (int y);
int (*cncout_go_z[10]) (int z);
int (*cncout_soft_start[10]) (int value);
int (*cncout_drill_on[10]) (void);
int (*cncout_drill_off[10]) (void);
int (*cncout_drill_set_speed[10]) (int speed);
int (*cncout_drill[10]) (void);
int (*cncout_pen[10]) (int updown);
int (*cncout_init[10]) (int num);

int cncout;
char cncout_name[128][10];
