
int ecad_select_ic(void) {
	if (event.button.button == 1) {
		sprintf(gui_info, "IC selected");
		ecad_select = SELECT_XY1;
		ecad_mouse_mode = M_DRAW;
		ecad_mode = DRAW_IC;
		ecad_clean_select();
		gui_select_icon(WidgetID[DRAW_IC]);
	}
	return 0;
}

int ecad_set_ic(int mode, int layer, int x1, int y1, int x2, int y2, int pad_size, int rotate) {
	ECAD[ecad_active_id].type = DRAW_IC;
	ECAD[ecad_active_id].x1 = x1;
	ECAD[ecad_active_id].y1 = y1;
	ECAD[ecad_active_id].x2 = x2;
	ECAD[ecad_active_id].y2 = y2;
	ECAD[ecad_active_id].size = pad_size;
	ECAD[ecad_active_id].dtype = ecad_padtype;
	ECAD[ecad_active_id].rotate = 0;
	ECAD[ecad_active_id].mode = mode;
	ECAD[ecad_active_id].view = 1;
	ECAD[ecad_active_id].layer = ecad_active_layer;
	ECAD[ecad_active_id].text[0] = 0;
	sprintf(ECAD[ecad_active_id].info, "IC-Sockel / %ipol", ECAD[ecad_active_id].y2 * 2);
	return 0;
}

int ecad_draw_ic(int ecad_id) {
	SDL_Rect dstrect;
	SDL_Surface *text_img = NULL;
	SDL_Color color;
	int x1;
	int y1;
	int x2;
	int y2;
	int pin_n = 0;
	for (pin_n = 0; pin_n < ((ECAD[ecad_id].x2 - ECAD[ecad_id].x1) / 254) + 1; pin_n++) {
		ecad_add_pad(ECAD[ecad_id].x1 + (pin_n * 254), ECAD[ecad_id].y1, ECAD[ecad_id].size, ECAD[ecad_id].dtype);
		ecad_add_pad(ECAD[ecad_id].x1 + (pin_n * 254), ECAD[ecad_id].y2, ECAD[ecad_id].size, ECAD[ecad_id].dtype);
		if (ecad_show_top_label == 1) {
		}
	}
	if (ecad_show_top_label == 1) {
		rectangleRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1 - 127), ecad_zoom_int(ECAD[ecad_id].y1 + 127), ecad_zoom_int(ECAD[ecad_id].x1 + (((ECAD[ecad_id].x2 - ECAD[ecad_id].x1) / 254) * 254) + 127), ecad_zoom_int(ECAD[ecad_id].y2 - 127), tl_r, tl_g, tl_b, tl_a);
		x1 = ecad_zoom_int(ECAD[ecad_id].x1 - 127);
		y1 = ecad_zoom_int(ECAD[ecad_id].y1 + 127);
		x2 = ecad_zoom_int(ECAD[ecad_id].x1 + (((ECAD[ecad_id].x2 - ECAD[ecad_id].x1) / 254) * 254) + 127);
		y2 = ecad_zoom_int(ECAD[ecad_id].y2 - 127);

		glBegin(GL_QUADS);
		glColor4f(0.3, 0.3, 0.3, 1.0);
		glVertex3f(x1, y1, 200.0 * ecad_zoom);
		glVertex3f(x2, y1, 200.0 * ecad_zoom);
		glVertex3f(x2, y2, 200.0 * ecad_zoom);
		glVertex3f(x1, y2, 200.0 * ecad_zoom);
		glColor4f(0.2, 0.2, 0.2, 1.0);
		glVertex3f(x1, y1, 200.0 * ecad_zoom);
		glVertex3f(x2, y1, 200.0 * ecad_zoom);
		glVertex3f(x2, y1, 2.0);
		glVertex3f(x1, y1, 2.0);
		glVertex3f(x1, y2, 200.0 * ecad_zoom);
		glVertex3f(x2, y2, 200.0 * ecad_zoom);
		glVertex3f(x2, y2, 2.0);
		glVertex3f(x1, y2, 2.0);
		glVertex3f(x2, y1, 200.0 * ecad_zoom);
		glVertex3f(x2, y1, 2.0);
		glVertex3f(x2, y2, 2.0);
		glVertex3f(x2, y2, 20.0 * ecad_zoom);
		glVertex3f(x1, y1, 200.0 * ecad_zoom);
		glVertex3f(x1, y1, 2.0);
		glVertex3f(x1, y2, 2.0);
		glVertex3f(x1, y2, 200.0 * ecad_zoom);
		glEnd();
	}
	return 0;
}

int ecad_mdown_ic(void) {
	return 0;
}

int ecad_mup_ic(void) {
	if (ecad_select == SELECT_XY1) {
		ecad_x1 = event.button.x;
		ecad_y1 = event.button.y;
		ecad_x2 = ecad_x1;
		ecad_y2 = ecad_y1;
		ecad_select = SELECT_XY2;
	} else if (ecad_select == SELECT_XY2) {
		ecad_x2 = event.button.x;
		ecad_y2 = event.button.y;
		ecad_select = SELECT_XY1;
		ecad_set_ic(1, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_padsize, ecad_rotate);
		ecad_active_id = ecad_get_free_id();
	}
	return 0;
}

int ecad_mover_ic(void) {
	if (ecad_select == SELECT_XY1) {
		ecad_x1 = event.button.x;
		ecad_y1 = event.button.y;
		ecad_x2 = ecad_x1;
		ecad_y2 = ecad_y1;
		sprintf(gui_info, "IC-Possition: x=%0.1fmm, y=%0.1fmm", (float)ecad_x1 / 10.0, (float)ecad_y1 / 10.0);
		ecad_set_ic(0, ecad_active_layer, ecad_x1, ecad_y1, 1, 1, ecad_padsize, ecad_rotate);
	} else if (ecad_select == SELECT_XY2) {
		ecad_x2 = event.button.x;
		ecad_y2 = event.button.y;
		sprintf(gui_info, "IC-Pins=%i, IC-Width=%i", (int)((ecad_x2 - ecad_x1) / (ecad_raster * 2) + 1), (int)(ecad_y2 - ecad_y1));
		ecad_set_ic(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_padsize, ecad_rotate);
	}
	return 0;
}

int ecad_input_ic(char *txt_str) {
	static int str_ptr = 0;
	static char tmp_str[256];
	if (str_ptr != 0 && strcmp(txt_str, "escape") == 0) {
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "backspace") == 0) {
		if (str_ptr > 0) {
			str_ptr--;
		}
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "space") == 0) {
		tmp_str[str_ptr++] = ' ';
		tmp_str[str_ptr] = 0;
	} else if (txt_str[0] != 0 && txt_str[1] == 0) {
		tmp_str[str_ptr++] = txt_str[0];
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "return") == 0 || strcmp(txt_str, "enter") == 0) {
		char *loc;
		fprintf(stderr, "%s\n", tmp_str);
		if ((loc = strstr(tmp_str, ",")) != 0) {
			if (ecad_select == SELECT_XY1) {
				ecad_x1 = atoi(tmp_str);
				ecad_y1 = atoi(loc + 1);
				ecad_x2 = 7 * (ecad_raster * 2);
				ecad_y2 = ecad_x1 + 10;
				ecad_select = SELECT_XY2;
				ecad_set_ic(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_padsize, ecad_rotate);
			} else if (ecad_select == SELECT_XY2) {
				ecad_x2 = (atoi(tmp_str) - 1) * (ecad_raster * 2);
				ecad_y2 = atoi(loc + 1);
				ecad_select = SELECT_XY1;
				ecad_set_ic(1, ecad_active_layer, ecad_x1, ecad_y1, ecad_x2, ecad_y2, ecad_padsize, ecad_rotate);
				ecad_active_id = ecad_get_free_id();
			}
		}
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else {
		return 1;
	}
	frontend_draw_info(tmp_str);
	return 0;
}


