
FILE *cncout_dxf_stream = NULL;

int cncout_dxf_check_z(void) {
	return 0;
}

int cncout_dxf_set_speed_xy(int speed) {
	return 0;
}

int cncout_dxf_set_speed_z(int speed) {
	return 0;
}

int cncout_dxf_soft_start(int value) {
	return 0;
}

int cncout_dxf_reset(void) {
	return 0;
}

int cncout_dxf_start(int x, int y) {
	if ((cncout_dxf_stream = fopen("/tmp/dxf-out.dxf", "w")) != 0) {
		fprintf(cncout_dxf_stream, "  0\n");
		fprintf(cncout_dxf_stream, "SECTION\n");
		fprintf(cncout_dxf_stream, "  2\n");
		fprintf(cncout_dxf_stream, "ENTITIES\n");
		cnc_active = 1;
	} else {
		cncout_dxf_stream = NULL;
		cnc_active = 0;
	}
	return 0;
}

int cncout_dxf_stop(void) {
	fprintf(cncout_dxf_stream, " 0\n");
	fprintf(cncout_dxf_stream, "ENDSEC\n");
	fprintf(cncout_dxf_stream, "  0\n");
	fprintf(cncout_dxf_stream, "EOF\n");
	if (cncout_dxf_stream != NULL) {
		fclose(cncout_dxf_stream);
	}
	cnc_active = 0;
	return 0;
}

int cncout_dxf_off(void) {
	return 0;
}

int cncout_dxf_tool_change(int tool_nr) {
	return 0;
}

int cncout_dxf_go_xy(int x, int y) {
	if (cnc_last_z > z_start) {
		// Line-Mode
		fprintf(cncout_dxf_stream, "  0\n");
		fprintf(cncout_dxf_stream, "LINE\n");
		// Layer 0
		fprintf(cncout_dxf_stream, "  8\n");
		fprintf(cncout_dxf_stream, "0\n");
		// X-Cord
		fprintf(cncout_dxf_stream, " 10\n");
		fprintf(cncout_dxf_stream, "%0.2f\n", (float)cnc_last_x / 100.0);
		// Y-Cord
		fprintf(cncout_dxf_stream, " 20\n");
		fprintf(cncout_dxf_stream, "%0.2f\n", (float)cnc_last_y / 100.0);
		// Z-Cord
		fprintf(cncout_dxf_stream, " 30\n");
		fprintf(cncout_dxf_stream, "0.0\n");
		// X-Cord
		fprintf(cncout_dxf_stream, " 11\n");
		fprintf(cncout_dxf_stream, "%0.2f\n", (float)x / 100.0);
		// Y-Cord
		fprintf(cncout_dxf_stream, " 21\n");
		fprintf(cncout_dxf_stream, "%0.2f\n", (float)y / 100.0);
		// Z-Cord
		fprintf(cncout_dxf_stream, " 31\n");
		fprintf(cncout_dxf_stream, "0.0\n");

	}
	cnc_last_y = y;
	cnc_last_x = x;
	return 0;
}

int cncout_dxf_go_x(int x) {
	cnc_last_x = x;
	return 0;
}

int cncout_dxf_go_y(int y) {
	cnc_last_y = y;
	return 0;
}

int cncout_dxf_go_z(int pos_z) {
	cnc_last_z = pos_z;
	cnc_last_tool_offset = ZAxis[cnc_tool_active].offset_z;
	return 0;
}

int cncout_dxf_drill_on(void) {
	return 0;
}

int cncout_dxf_drill_off(void) {
	return 0;
}

int cncout_dxf_drill_set_speed(int speed) {
	return 0;
}

int cncout_dxf_drill(void) {
	return 0;
}

int cncout_dxf_pen(int updown) {
	char cmd[256];
	if (cnc_last_updown != updown) {
		if (updown == 3) {
			cnc_last_updown = updown;
		} else if (updown == 2) {
			cnc_last_updown = 1;
		} else if (updown == 1) {
			cnc_last_updown = updown;
		} else if (updown == 0) {
			cnc_last_updown = updown;
		}
	}
	return 0;
}

int cncout_dxf_init(int num) {
	cncout_check_z[num] = cncout_dxf_check_z;
	cncout_set_speed_xy[num] = cncout_dxf_set_speed_xy;
	cncout_set_speed_z[num] = cncout_dxf_set_speed_z;
	cncout_reset[num] = cncout_dxf_reset;
	cncout_start[num] = cncout_dxf_start;
	cncout_stop[num] = cncout_dxf_stop;
	cncout_off[num] = cncout_dxf_off;
	cncout_tool_change[num] = cncout_dxf_tool_change;
	cncout_soft_start[num] = cncout_dxf_soft_start;
	cncout_go_xy[num] = cncout_dxf_go_xy;
	cncout_go_x[num] = cncout_dxf_go_x;
	cncout_go_y[num] = cncout_dxf_go_y;
	cncout_go_z[num] = cncout_dxf_go_z;
	cncout_drill_on[num] = cncout_dxf_drill_on;
	cncout_drill_off[num] = cncout_dxf_drill_off;
	cncout_drill_set_speed[num] = cncout_dxf_drill_set_speed;
	cncout_drill[num] = cncout_dxf_drill;
	cncout_pen[num] = cncout_dxf_pen;
	strcpy(cncout_name[num], "DXF-Output");
	return 0;
}


