
SDL_Surface *CNC_PreviewSurface;

int cncout_preview_check_z(void) {
	return 0;
}

int cncout_preview_set_speed_xy(int speed) {
	return 0;
}

int cncout_preview_set_speed_z(int speed) {
	return 0;
}

int cncout_preview_reset(void) {
	return 0;
}

int cncout_preview_start(int x, int y) {
	CNC_PreviewSurface = SDL_CreateRGBSurface(SDL_SWSURFACE, x, y, 32, rmask, gmask, bmask, amask);
	cnc_active = 1;
	return 0;
}

int cncout_preview_stop(void) {
	SDL_SaveBMP(CNC_PreviewSurface, "/tmp/Outliner.bmp");
	SDL_FreeSurface(CNC_PreviewSurface);
	cnc_active = 0;
	return 0;
}

int cncout_preview_off(void) {
	return 0;
}

int cncout_preview_tool_change(int tool_nr) {
	return 0;
}

int cncout_preview_go_xy(int x, int y) {
	if (cnc_last_z > z_start) {
		lineRGBA(CNC_PreviewSurface, cnc_last_x, cnc_last_y, x, y, 255, 0, 0, 255);
	}
	pixelRGBA(CNC_PreviewSurface, cnc_last_x, cnc_last_y, 0, 255, 255, 255);
	pixelRGBA(CNC_PreviewSurface, x, y, 255, 255, 255, 255);
	cnc_last_y = y;
	cnc_last_x = x;
	return 0;
}

int cncout_preview_go_x(int x) {
	if (cnc_last_z > z_start) {
		lineRGBA(CNC_PreviewSurface, cnc_last_x, cnc_last_y, x, cnc_last_y, 255, 0, 0, 255);
	}
	pixelRGBA(CNC_PreviewSurface, cnc_last_x, cnc_last_y, 0, 255, 255, 255);
	pixelRGBA(CNC_PreviewSurface, x, cnc_last_y, 255, 255, 255, 255);
	cnc_last_x = x;
	return 0;
}

int cncout_preview_go_y(int y) {
	if (cnc_last_z > z_start) {
		lineRGBA(CNC_PreviewSurface, cnc_last_x, cnc_last_y, cnc_last_x, y, 255, 0, 0, 255);
	}
	pixelRGBA(CNC_PreviewSurface, cnc_last_x, cnc_last_y, 0, 255, 255, 255);
	pixelRGBA(CNC_PreviewSurface, cnc_last_x, y, 255, 255, 255, 255);
	cnc_last_y = y;
	return 0;
}

int cncout_preview_go_z(int pos_z) {
	cnc_last_z = pos_z;
	cnc_last_tool_offset = ZAxis[cnc_tool_active].offset_z;
	return 0;
}

int cncout_preview_drill_on(void) {
	return 0;
}

int cncout_preview_drill_off(void) {
	return 0;
}

int cncout_preview_drill_set_speed(int speed) {
	return 0;
}

int cncout_preview_drill(void) {
	return 0;
}

int cncout_preview_pen(int updown) {
	if (cnc_last_updown != updown) {
		if (updown == 3) {
			cnc_last_updown = updown;
		} else if (updown == 2) {
			cnc_last_updown = 1;
		} else if (updown == 1) {
			cnc_last_updown = updown;
		} else if (updown == 0) {
			cnc_last_updown = updown;
		}
	}
	return 0;
}

int cncout_preview_init(int num) {
	cncout_check_z[num] = cncout_preview_check_z;
	cncout_set_speed_xy[num] = cncout_preview_set_speed_xy;
	cncout_set_speed_z[num] = cncout_preview_set_speed_z;
	cncout_reset[num] = cncout_preview_reset;
	cncout_start[num] = cncout_preview_start;
	cncout_stop[num] = cncout_preview_stop;
	cncout_off[num] = cncout_preview_off;
	cncout_tool_change[num] = cncout_preview_tool_change;
	cncout_go_xy[num] = cncout_preview_go_xy;
	cncout_go_x[num] = cncout_preview_go_x;
	cncout_go_y[num] = cncout_preview_go_y;
	cncout_go_z[num] = cncout_preview_go_z;
	cncout_drill_on[num] = cncout_preview_drill_on;
	cncout_drill_off[num] = cncout_preview_drill_off;
	cncout_drill_set_speed[num] = cncout_preview_drill_set_speed;
	cncout_drill[num] = cncout_preview_drill;
	cncout_pen[num] = cncout_preview_pen;
	strcpy(cncout_name[num], "2D-Preview");
	return 0;
}


