
FILE *cncout_hpgl_stream = NULL;

int cncout_hpgl_check_z(void) {
	return 0;
}

int cncout_hpgl_set_speed_xy(int speed) {
	return 0;
}

int cncout_hpgl_set_speed_z(int speed) {
	return 0;
}

int cncout_hpgl_soft_start(int value) {
	return 0;
}

int cncout_hpgl_reset(void) {
	fprintf(cncout_hpgl_stream, "PU;\n");
	return 0;
}

int cncout_hpgl_start(int x, int y) {
	if ((cncout_hpgl_stream = fopen("/tmp/hpgl-out.plt", "w")) != 0) {
		fprintf(cncout_hpgl_stream, "IN;\n");
		fprintf(cncout_hpgl_stream, "IW0,0,%i,%i;\n", x * 4, y * 4);
		fprintf(cncout_hpgl_stream, "PU;\n");
		fprintf(cncout_hpgl_stream, "SP%i;\n", cnc_tool_active + 1);
		cnc_active = 1;
	} else {
		cncout_hpgl_stream = NULL;
		cnc_active = 0;
	}
	return 0;
}

int cncout_hpgl_stop(void) {
	fprintf(cncout_hpgl_stream, "PU;\n");
	fprintf(cncout_hpgl_stream, "\n");
	if (cncout_hpgl_stream != NULL) {
		fclose(cncout_hpgl_stream);
	}
	cnc_active = 0;
	return 0;
}

int cncout_hpgl_off(void) {
	fprintf(cncout_hpgl_stream, "PU;\n");
	return 0;
}

int cncout_hpgl_tool_change(int tool_nr) {
	fprintf(cncout_hpgl_stream, "SP%i;\n", tool_nr + 1);
	return 0;
}

int cncout_hpgl_go_xy(int x, int y) {
	fprintf(cncout_hpgl_stream, "PA%ix%i;\n", (int)((float)x * 4), (int)((float)y * 4));
	cnc_last_y = y;
	cnc_last_x = x;
	return 0;
}

int cncout_hpgl_go_x(int x) {
	cnc_last_x = x;
	return 0;
}

int cncout_hpgl_go_y(int y) {
	cnc_last_y = y;
	return 0;
}

int cncout_hpgl_go_z(int pos_z) {
	if (pos_z < z_start) {
		fprintf(cncout_hpgl_stream, "PU;\n");
	} else {
		fprintf(cncout_hpgl_stream, "PD;\n");
	}
	cnc_last_z = pos_z;
	cnc_last_tool_offset = ZAxis[cnc_tool_active].offset_z;
	return 0;
}

int cncout_hpgl_drill_on(void) {
	return 0;
}

int cncout_hpgl_drill_off(void) {
	return 0;
}

int cncout_hpgl_drill_set_speed(int speed) {
	return 0;
}

int cncout_hpgl_drill(void) {
	return 0;
}

int cncout_hpgl_pen(int updown) {
	char cmd[256];
	if (cnc_last_updown != updown) {
		if (updown == 3) {
			fprintf(cncout_hpgl_stream, "PU;\n");
			cnc_last_updown = updown;
		} else if (updown == 2) {
			fprintf(cncout_hpgl_stream, "PD;\n");
			cnc_last_updown = 1;
		} else if (updown == 1) {
			fprintf(cncout_hpgl_stream, "PD;\n");
			cnc_last_updown = updown;
		} else if (updown == 0) {
			fprintf(cncout_hpgl_stream, "PU;\n");
			cnc_last_updown = updown;
		}
	}
	return 0;
}

int cncout_hpgl_init(int num) {
	cncout_check_z[num] = cncout_hpgl_check_z;
	cncout_set_speed_xy[num] = cncout_hpgl_set_speed_xy;
	cncout_set_speed_z[num] = cncout_hpgl_set_speed_z;
	cncout_reset[num] = cncout_hpgl_reset;
	cncout_start[num] = cncout_hpgl_start;
	cncout_stop[num] = cncout_hpgl_stop;
	cncout_off[num] = cncout_hpgl_off;
	cncout_tool_change[num] = cncout_hpgl_tool_change;
	cncout_soft_start[num] = cncout_hpgl_soft_start;
	cncout_go_xy[num] = cncout_hpgl_go_xy;
	cncout_go_x[num] = cncout_hpgl_go_x;
	cncout_go_y[num] = cncout_hpgl_go_y;
	cncout_go_z[num] = cncout_hpgl_go_z;
	cncout_drill_on[num] = cncout_hpgl_drill_on;
	cncout_drill_off[num] = cncout_hpgl_drill_off;
	cncout_drill_set_speed[num] = cncout_hpgl_drill_set_speed;
	cncout_drill[num] = cncout_hpgl_drill;
	cncout_pen[num] = cncout_hpgl_pen;
	strcpy(cncout_name[num], "HPGL-Output");
	return 0;
}


