
int get_diff(int val1, int val2) {
	if (val1 > val2) {
		return(val1 - val2);
	} else if (val1 < val2) {
		return(val2 - val1);
	}
	return 0;
}

int cnc_2d_liner(unsigned char *img_data, int width, int z_pos, int min_x, int min_y, int max_x, int max_y, int mode) {
	// Layer -> CNC-Machine
	int test_x = 0;
	int test_y = 0;
	int test2_x = 0;
	int test2_y = 0;
	int last_x = 0;
	int last_y = 0;
	int first_x = 0;
	int first_y = 0;
	int dir_x = 0;
	int dir_y = 0;
	int ldir_x = 0;
	int ldir_y = 0;
	int radius = 0;
	int y_addr = 0;
	if (min_x < 0) {min_x = 0;}
	if (min_y < 0) {min_y = 0;}
	for (test2_y = min_y; cnc_active == 1 && test2_y <= max_y; test2_y++) {
		test_y = test2_y;
		y_addr = (test_y * width);
		for (test2_x = min_x; test2_x <= max_x; test2_x++) {
			test_x = test2_x;
			if (img_data[y_addr + test_x] == IMG_DATA_MARK2) {
				img_data[(test_y * width) + test_x] = IMG_DATA_MARK3;
				cnc_go_xy(test_x, test_y);
				first_x = test_x;
				first_y = test_y;
				last_x = test_x;
				last_y = test_y;
				ldir_x = 0;
				ldir_y = 0;
				cnc_drill_set_speed(255);
				cnc_go_z(z_pos);
				int diff = 1;
				while (cnc_active == 1) {
					if (img_data[(test_y * width) + (test_x + diff)] == IMG_DATA_MARK2) {
						test_x += diff;
						dir_x = 1;
						dir_y = 0;
					} else if (img_data[(test_y * width) + (test_x - diff)] == IMG_DATA_MARK2) {
						test_x -= diff;
						dir_x = -1;
						dir_y = 0;
					} else if (img_data[((test_y + diff) * width) + test_x] == IMG_DATA_MARK2) {
						test_y += diff;
						dir_x = 0;
						dir_y = 1;
					} else if (img_data[((test_y - diff) * width) + test_x] == IMG_DATA_MARK2) {
						test_y -= diff;
						dir_x = 0;
						dir_y = -1;
					} else if (img_data[((test_y + diff) * width) + (test_x + diff)] == IMG_DATA_MARK2) {
						test_x += diff;
						test_y += diff;
						dir_x = 1;
						dir_y = 1;
					} else if (img_data[((test_y - diff) * width) + (test_x + diff)] == IMG_DATA_MARK2) {
						test_x += diff;
						test_y -= diff;
						dir_x = 1;
						dir_y = -1;
					} else if (img_data[((test_y - diff) * width) + (test_x - diff)] == IMG_DATA_MARK2) {
						test_x -= diff;
						test_y -= diff;
						dir_x = -1;
						dir_y = -1;
					} else if (img_data[((test_y + diff) * width) + (test_x - diff)] == IMG_DATA_MARK2) {
						test_x -= diff;
						test_y += diff;
						dir_x = -1;
						dir_y = 1;
					} else {
						break;
					}
					img_data[(test_y * width) + test_x] = IMG_DATA_MARK3;
					if (ldir_x != dir_x || ldir_y != dir_y) {
						cnc_go_xy(last_x, last_y);
						cnc_go_xy(test_x, test_y);
					}
					last_x = test_x;
					last_y = test_y;
					ldir_x = dir_x;
					ldir_y = dir_y;
					gui_check();
					cnc_active = gui_running;
					gui_running = 1;
				}
				cnc_go_xy(last_x, last_y);
				if (get_diff(first_x, test_x) < ZAxis[cnc_tool_active].tool.head.radius && get_diff(first_y, test_y) < ZAxis[cnc_tool_active].tool.head.radius) {
					cnc_go_xy(first_x, first_y);
				}
				cnc_go_z(z_start - cnc_zover);
				cnc_drill_set_speed(0);
			}
		}
	}
	return 0;
}


