
int ecad_select_pinconn(void) {
	if (event.button.button == 1) {
		ecad_select = SELECT_XY1;
		ecad_mouse_mode = M_DRAW;
		ecad_mode = DRAW_PINCONN;
		ecad_clean_select();
		gui_select_icon(WidgetID[DRAW_PINCONN]);
		sprintf(gui_info, "Connector-Pin selected");
	}
	return 0;
}

int ecad_set_pinconn(int mode, int layer, int x1, int y1, int pinconn_size, int rotate) {
	ECAD[ecad_active_id].type = DRAW_PINCONN;
	ECAD[ecad_active_id].x1 = x1;
	ECAD[ecad_active_id].y1 = y1;
	ECAD[ecad_active_id].x2 = x1;
	ECAD[ecad_active_id].y2 = y1;
	ECAD[ecad_active_id].size = pinconn_size;
	ECAD[ecad_active_id].dtype = ecad_padtype;
	ECAD[ecad_active_id].rotate = 0;
	ECAD[ecad_active_id].mode = mode;
	ECAD[ecad_active_id].view = 1;
	ECAD[ecad_active_id].layer = ecad_active_layer;
	ECAD[ecad_active_id].text[0] = 0;
	strcpy(ECAD[ecad_active_id].info, "Connector-Pin");
	return 0;
}

int ecad_draw_pinconn(int ecad_id) {
	int x1;
	int y1;
	int x2;
	int y2;
	ecad_add_pad(ECAD[ecad_id].x1, ECAD[ecad_id].y1, ECAD[ecad_id].size, ECAD[ecad_id].dtype);
	if (ecad_show_top_label == 1) {
		lineRGBA(ECAD_Surface, ecad_zoom_int(ECAD[ecad_id].x1 - 120), ecad_zoom_int(ECAD[ecad_id].y1 - 120), ecad_zoom_int(ECAD[ecad_id].x1 + 120), ecad_zoom_int(ECAD[ecad_id].y1 + 120), tl_r, tl_g, tl_b, tl_a);
		x1 = ecad_zoom_int(ECAD[ecad_id].x1 - 120);
		y1 = ecad_zoom_int(ECAD[ecad_id].y1 - 120);
		x2 = ecad_zoom_int(ECAD[ecad_id].x1 + 120);
		y2 = ecad_zoom_int(ECAD[ecad_id].y1 + 120);
		glBegin(GL_QUADS);
		glColor4f(0.2, 0.2, 0.2, 1.0);
		glVertex3f(x1, y1, 200.0 * ecad_zoom);
		glVertex3f(x2, y1, 200.0 * ecad_zoom);
		glVertex3f(x2, y2, 200.0 * ecad_zoom);
		glVertex3f(x1, y2, 200.0 * ecad_zoom);
		glColor4f(0.1, 0.1, 0.1, 1.0);
		glVertex3f(x1, y1, 200.0 * ecad_zoom);
		glVertex3f(x2, y1, 200.0 * ecad_zoom);
		glVertex3f(x2, y1, 2.0);
		glVertex3f(x1, y1, 2.0);
		glVertex3f(x1, y2, 200.0 * ecad_zoom);
		glVertex3f(x2, y2, 200.0 * ecad_zoom);
		glVertex3f(x2, y2, 2.0);
		glVertex3f(x1, y2, 2.0);
		glVertex3f(x2, y1, 200.0 * ecad_zoom);
		glVertex3f(x2, y1, 2.0);
		glVertex3f(x2, y2, 2.0);
		glVertex3f(x2, y2, 20.0 * ecad_zoom);
		glVertex3f(x1, y1, 200.0 * ecad_zoom);
		glVertex3f(x1, y1, 2.0);
		glVertex3f(x1, y2, 2.0);
		glVertex3f(x1, y2, 200.0 * ecad_zoom);
		glEnd();
		x1 = ecad_zoom_int(ECAD[ecad_id].x1 - 50);
		y1 = ecad_zoom_int(ECAD[ecad_id].y1 - 50);
		x2 = ecad_zoom_int(ECAD[ecad_id].x1 + 50);
		y2 = ecad_zoom_int(ECAD[ecad_id].y1 + 50);
		glBegin(GL_QUADS);
		glColor4f(tl_r / 255, tl_g / 255, tl_b / 255, 1.0);
		glVertex3f(x1, y1, 500.0 * ecad_zoom);
		glVertex3f(x2, y1, 500.0 * ecad_zoom);
		glVertex3f(x2, y2, 500.0 * ecad_zoom);
		glVertex3f(x1, y2, 500.0 * ecad_zoom);
		glColor4f(tl_r / 250, tl_g / 250, tl_b / 250, 1.0);
		glVertex3f(x1, y1, 500.0 * ecad_zoom);
		glVertex3f(x2, y1, 500.0 * ecad_zoom);
		glVertex3f(x2, y1, 2.0);
		glVertex3f(x1, y1, 2.0);
		glColor4f(tl_r / 250, tl_g / 250, tl_b / 250, 1.0);
		glVertex3f(x1, y2, 500.0 * ecad_zoom);
		glVertex3f(x2, y2, 500.0 * ecad_zoom);
		glVertex3f(x2, y2, 2.0);
		glVertex3f(x1, y2, 2.0);
		glColor4f(tl_r / 250, tl_g / 250, tl_b / 250, 1.0);
		glVertex3f(x2, y1, 500.0 * ecad_zoom);
		glVertex3f(x2, y1, 2.0);
		glVertex3f(x2, y2, 2.0);
		glVertex3f(x2, y2, 500.0 * ecad_zoom);
		glColor4f(tl_r / 250, tl_g / 250, tl_b / 250, 1.0);
		glVertex3f(x1, y1, 500.0 * ecad_zoom);
		glVertex3f(x1, y1, 2.0);
		glVertex3f(x1, y2, 2.0);
		glVertex3f(x1, y2, 500.0 * ecad_zoom);
		glEnd();
	}
	return 0;
}

int ecad_mdown_pinconn(void) {
	return 0;
}

int ecad_mup_pinconn(void) {
	if (event.button.button == 1) {
		if (ecad_select == SELECT_XY1) {
			ecad_x1 = event.button.x;
			ecad_y1 = event.button.y;
			ecad_x2 = ecad_x1;
			ecad_y2 = ecad_y1;
			ecad_set_pinconn(1, ecad_active_layer, ecad_x1, ecad_y1, ecad_padsize, ecad_rotate);
			ecad_active_id = ecad_get_free_id();
		}
	}
	return 0;
}

int ecad_mover_pinconn(void) {
	if (ecad_select == SELECT_XY1) {
		ecad_x1 = event.button.x;
		ecad_y1 = event.button.y;
		ecad_x2 = ecad_x1;
		ecad_y2 = ecad_y1;
		sprintf(gui_info, "Pin-Possition: x=%0.1fmm, y=%0.1fmm", (float)ecad_x1 / 10.0, (float)ecad_y1 / 10.0);
		ecad_set_pinconn(0, ecad_active_layer, ecad_x1, ecad_y1, ecad_padsize, ecad_rotate);
	}
	return 0;
}

int ecad_input_pinconn(char *txt_str) {
	static int str_ptr = 0;
	static char tmp_str[256];
	if (str_ptr != 0 && strcmp(txt_str, "escape") == 0) {
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "backspace") == 0) {
		if (str_ptr > 0) {
			str_ptr--;
		}
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "space") == 0) {
		tmp_str[str_ptr++] = ' ';
		tmp_str[str_ptr] = 0;
	} else if (txt_str[0] != 0 && txt_str[1] == 0) {
		tmp_str[str_ptr++] = txt_str[0];
		tmp_str[str_ptr] = 0;
	} else if (strcmp(txt_str, "return") == 0 || strcmp(txt_str, "enter") == 0) {
		char *loc;
		fprintf(stderr, "%s\n", tmp_str);
		if ((loc = strstr(tmp_str, ",")) != 0) {
			ecad_x1 = atoi(tmp_str);
			ecad_y1 = atoi(loc + 1);
			ecad_x2 = ecad_x1;
			ecad_y2 = ecad_y1;
			ecad_set_pinconn(1, ecad_active_layer, ecad_x1, ecad_y1, ecad_padsize, ecad_rotate);
			ecad_active_id = ecad_get_free_id();
		}
		str_ptr = 0;
		tmp_str[str_ptr] = 0;
	} else {
		return 1;
	}
	frontend_draw_info(tmp_str);
	return 0;
}


